//to represent a nonempty list of authors
class ConsLoA extends ALoA{
	public Author first;
	public ALoA rest;
	
	public ConsLoA(Author first, ALoA rest){
		this.first = first;
		this.rest = rest;
	}

	// does this list contain the given author
	public boolean contains(Author a){
		return this.first.same(a)
		    || this.rest.contains(a);
	}

	// count the authors in this list
	public int count(){ 
		return 1 + this.rest.count(); 
	}
	
	// add the given book to all authors in this list
	public void addBook(Book b){
		this.first.addBook(b);
		this.rest.addBook(b);
	}

	//  determine extensional equality of this and given list of authors
	public boolean sameLoA(ALoA alist){
		return alist.sameConsLoA(this);
	}
	
	// is this list the same as the given empty list
	public boolean sameConsLoA(ConsLoA alist){ 
		return this.first.same(alist.first)
		    && this.rest.same(alist.rest);
	}
	
	// provide the values of this instance represented as a String
	public String toString(){
		return "\n ConsLoA: " + 
		       "\n first: "   + this.first +
		       "\n rest: "    + this.rest + "\n";
	}
	
	/* Template
	 * 
     	 *   ... this.first ...
     	 *   ... this.first.sameName(Author a) ...
    	 *   ... this.first.same(Object obj...
    	 *   ... this.rest ...
    	 *   ... this.rest.contains(Book b) ...
     	 *   ... this.rest.toString() ...
    	 * 
	 */

}