
// to represent a nonempty list of books
class ConsLoB extends ALoB{
	public Book first;
	public ALoB rest;
	
	public ConsLoB(Book first, ALoB rest){
		this.first = first;
		this.rest = rest;
	}

	// does this list contain the given book
	public boolean contains(Book b){
		return this.first.same(b)
		    || this.rest.contains(b);
	}
	  
	// count the books in this list
	public int count(){ 
		return 1 + this.rest.count(); 
	}
	
	//  determine extensional equality of this and given list of books
	public boolean sameLoB(ALoB alist){
		return alist.sameConsLoB(this);
	}
	
	// is this list the same as the given empty list
	public boolean sameConsLoB(ConsLoB alist){ 
		return this.first.same(alist.first)
		    && this.rest.same(alist.rest);
	}
	
  	// are the titles of the books in this list and given list the same
  	public boolean sameTitles(ALoB books){
  		return books.sameTitlesCons(this);
  	}

  	// are the titles of the books in this list and given list the same
  	public boolean sameTitlesCons(ConsLoB books){
  		return this.first.title.compareTo(books.first.title) == 0
        	    && this.rest.sameTitles(books.rest);
  	}

	// provide the values of this instance represented as a String
	public String toString(){
		return "\n ConsLoB: " + 
		       "\n first: "   + this.first +
		       "\n rest: "    + this.rest + "\n";
	}
		
	// provide the titles of books in this list as a String
	public String titleString(){
		return "\nTitle: " + this.first.title + 
                this.rest.titleString();
	}
	
	/* Template
	 * 
    	 *   ... this.first ...
     	 *   ... this.first.title ...
     	 *   ... this.first.author ...
     	 *   ... this.first.year ...
     	 *   ... this.rest ...
     	 *   ... this.rest.contains(Book b) ...
     	 *   ... this.rest.toString() ...
     	 * 
	 */

}